'use strict';

exports.__esModule = true;
exports.FormErrors = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formContext = require('./form-context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormErrorsComponent = function (_React$Component) {
  (0, _inherits3.default)(FormErrorsComponent, _React$Component);

  function FormErrorsComponent() {
    (0, _classCallCheck3.default)(this, FormErrorsComponent);
    return (0, _possibleConstructorReturn3.default)(this, _React$Component.apply(this, arguments));
  }

  FormErrorsComponent.prototype.render = function render() {
    var _props = this.props,
        errors = _props.errors,
        errorList = _props.errorList,
        other = (0, _objectWithoutProperties3.default)(_props, ['errors', 'errorList']);

    return _react2.default.createElement(
      'div',
      other,
      errorList.map(function (error, index) {
        return _react2.default.createElement(
          'div',
          { key: index },
          error
        );
      })
    );
  };

  return FormErrorsComponent;
}(_react2.default.Component);

var FormErrors = function (_React$Component2) {
  (0, _inherits3.default)(FormErrors, _React$Component2);

  function FormErrors(props, context) {
    (0, _classCallCheck3.default)(this, FormErrors);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, _React$Component2.call(this, props, context));

    _this2.state = { errors: {} };
    return _this2;
  }

  FormErrors.prototype.componentDidMount = function componentDidMount() {
    var _this3 = this;

    this.subscriberId = this.context.form.validators.subscribe(function (errors) {
      var err = {};
      (_this3.props.errors || []).forEach(function (name) {
        err[name] = errors[name];
      });
      _this3.setState({ errors: err });
    });
  };

  FormErrors.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.subscriberId) {
      this.context.form.validators.removeSubscriber(this.subscriberId);
      this.subscriberId = null;
    }
  };

  FormErrors.prototype.render = function render() {
    var _this4 = this;

    var _props2 = this.props,
        component = _props2.component,
        errors = _props2.errors,
        other = (0, _objectWithoutProperties3.default)(_props2, ['component', 'errors']);

    var errorList = errors.map(function (key) {
      return _this4.state.errors[key];
    }).filter(function (error) {
      return !!error;
    });
    return _react2.default.createElement(component || FormErrorsComponent, (0, _extends3.default)({}, other, this.state, { errorList: errorList }));
  };

  return FormErrors;
}(_react2.default.Component);

FormErrors.propTypes = {
  errors: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.string).isRequired,
  component: _react2.default.PropTypes.func
};

FormErrors.contextTypes = {
  form: _react2.default.PropTypes.instanceOf(_formContext.FormContext).isRequired
};

exports.FormErrors = FormErrors;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormErrorsComponent, 'FormErrorsComponent', 'E:/Projects/React/git/vb-react-form/src/form-errors.js');

  __REACT_HOT_LOADER__.register(FormErrors, 'FormErrors', 'E:/Projects/React/git/vb-react-form/src/form-errors.js');
}();

;